import logging
from atgateway.app.sensing_mgr.const import Const
from atgateway.app.sensing_mgr.modules.lib.reporter import Reporter
from atgateway.app.sensing_mgr.modules.lib.report import Report


class CountReporter(Reporter):
    def __init__(self, start, interval):
        super().__init__()
        self._prop = {}
        self._prop["Count_polling_interval"] = interval

        self._oneshot = False
        self._oneshot_send = False
        self._start = start
        self._logging = logging.getLogger(Const.LOGGER_NAME)

        self._count = 0
        self._max_count = 100

    def data_type(self):
        return 'count_value'

    def oneshot_report(self):
        self._oneshot = True

    def report(self):
        report = None

        if self._start is False:
            return (report, None)
        if self._oneshot is False or \
                (self._oneshot is True and self._oneshot_send is False):

            report = Report.report_now(
                'measurement',
                Count_value=self._count
            )
            self._count += 1
            if (self._count > self._max_count):
                self._count = 0
            self._oneshot_send = True
        return (report, None)

#
# End of File
#
